﻿/*
 * -------------------------------------------------------------------------------
 * 功能描述：
 * 
 * 创建人：　	JunHan(俊涵)
 * 创建日期：	2013/12/13 22:53:45
 * 创建说明：	
 * 
 * 修改人：　	
 * 修改日期：	
 * 修改说明：	
 *    
 * -------------------------------------------------------------------------------
 */
using System;
using System.Collections.Generic;
using System.ComponentModel.Composition;
using System.ComponentModel.Composition.Hosting;
using System.Linq;
using System.Text;
using System.Web.Mvc;
using System.Web.Routing;

namespace WeDiscuss.Plugin.Framework
{
    public interface IMvcPlugin : IMvcPluginSys
    {
        List<SiteResource> Css { get; }
        List<SiteResource> JavaScript { get; }
        List<SiteResource> FooterJavaScript { get; }
        List<string> RazorViewLocations { get; }
        List<Widget> Widgets { get; }
        List<DynamicActionFilter> ActionFilters { get; }
        List<Route> Routes { get; }

        void SetupExtensions(IMvcPluginApplication app);

        bool Enabled { get; set; }
    }

    public interface IMvcPluginSys
    {
        void getFooterResources(StringBuilder footerOut);
        void getHeaderResources(StringBuilder headerOut);

        IMvcPluginApplication App { get; }
    }

    public interface IMvcPluginData
    {
        string Id { get; }
        string ParentId { get; }
        string Name { get; }
        string Description { get; }
    }

    [MetadataAttribute]
    [AttributeUsage(AttributeTargets.Class, AllowMultiple = false)]
    public class MvcPluginMetadataAttribute : ExportAttribute
    {
        public MvcPluginMetadataAttribute(string id, string parentId, string name, string description)
            : base(typeof(IMvcPluginData))
        {
            Id = id;
            ParentId = parentId;
            Name = name;
            Description = description;
        }

        public string Id { get; set; }
        public string ParentId { get; set; }
        public string Name { get; set; }
        public string Description { get; set; }
    }  
}
