﻿/*
 * -------------------------------------------------------------------------------
 * 功能描述：
 * 
 * 创建人：　	JunHan(俊涵)
 * 创建日期：	2013/12/15 23:29:58
 * 创建说明：	
 * 
 * 修改人：　	
 * 修改日期：	
 * 修改说明：	
 *    
 * -------------------------------------------------------------------------------
 */
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace WeDiscuss.Plugin.Framework
{
    public class PluginApplication : BaseMvcPluginApplication
    {
        #region Plugin Menu Support
        public static PluginMenus PluginMenus = new PluginMenus();
        public void RegisterMenuItem(PluginMenu menu)
        {
            lock (PluginMenus)
            {
                if (PluginMenus.MenuList == null) PluginMenus.MenuList = new List<PluginMenu>();
                PluginMenus.MenuList.Add(new PluginMenu() { MenuText = menu.MenuText, MenuUrl = menu.MenuUrl, MenuType = menu.MenuType, MenuOrder = menu.MenuOrder });
                PluginMenus.MenuList = PluginMenus.MenuList.OrderBy(o => o.MenuOrder).ToList();
            }
        }
        #endregion

        public static new PluginApplication Instance
        {
            get { return BaseMvcPluginApplication.Instance as PluginApplication; }
            set { BaseMvcPluginApplication.Instance = value; }
        }


        protected override bool ShouldIncludeResourceCore(BaseMvcPluginApplication.ResourceTypes type, IMvcPlugin plugin)
        {
            return ShouldIncludeResource(plugin, null);
        }

        protected virtual bool ShouldIncludeResource(IMvcPlugin plugin, object resource)
        {
            bool should = true;
            if (plugin != null)
            {
                if ((should = plugin.Enabled) && plugin is AppPlugin)
                    should = ((AppPlugin)plugin).ShouldIncludeResource(resource);
            }

            return should;
        }

        protected override void AddAdditionalRazorViewLocationsCore(List<string> lst)
        {
            lst.Add("~/Plugins/PluginDemo/Views.{1}.{0}.cshtml");
        }


        public static PluginApplication SetupApplication(object bundles, object routes)
        {
            PluginApplication me = new PluginApplication(bundles, routes);
            return me;
        }

        protected PluginApplication(object bundles, object routes)
            : base(bundles, routes)
        {
        }
    }

    public class AppPlugin : BaseMvcPlugin
    {
        public PluginApplication _App { get { return (PluginApplication)App; } }

        public AppPlugin(bool ensureStandardViewLocation = true)
            : base(ensureStandardViewLocation)
        {
        }

        public void DefineMenuItem(PluginMenu item)
        {
            _App.RegisterMenuItem(item);
        }

        public virtual bool ShouldIncludeResource(object content)
        {
            return true;
        }
    }
}

