﻿/*
 * -------------------------------------------------------------------------------
 * 功能描述：
 * 
 * 创建人：　	JunHan(俊涵)
 * 创建日期：	2013/12/15 21:59:16
 * 创建说明：	
 * 
 * 修改人：　	
 * 修改日期：	
 * 修改说明：	
 *    
 * -------------------------------------------------------------------------------
 */
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Web.Mvc;

namespace WeDiscuss.Plugin.Framework
{
    public class PluginMenus
    {
        public List<PluginMenu> MenuList { get; set; }

        public string CssClass { get; set; }

        public int MenuType { get; set; }

        public string Html
        {
            get
            {
                StringBuilder stringBuilder = new StringBuilder();
                foreach (var menu in MenuList)
                {
                    TagBuilder tagBuilder = new TagBuilder("a");
                    tagBuilder.MergeAttribute("href", menu.MenuUrl);
                    tagBuilder.InnerHtml = menu.MenuText;
                    tagBuilder.MergeAttribute("class", CssClass);
                    stringBuilder.Append(tagBuilder.ToString(TagRenderMode.Normal) + "\r\n");
                }
                return stringBuilder.ToString();
            }
        }

        public List<PluginMenu> AvailableList
        {
            get
            {
                if (MenuList == null)
                {
                    return new List<PluginMenu>();
                }
                if (MenuType == 0)
                {
                    return MenuList;
                }
                if (!MenuList.Any(o => o.MenuType == MenuType))
                {
                    return new List<PluginMenu>();
                }
                return MenuList.Where(o => o.MenuType == MenuType).ToList();
            }
        }
    }

    public class PluginMenu
    {
        public string MenuText { get; set; }
        public string MenuUrl { get; set; }

        public int MenuType { get; set; }

        public int MenuOrder { get; set; }

        public bool Visible { get; set; }
    }
}
